//importing modules select, json, geoPath, geoAzimuthalEqualArea functions from d3
import { select, json, geoPath, geoAzimuthalEqualArea} from 'd3';
//importing feature method from TopoJSON 
import { feature } from 'topojson';

//creating a svg constant
const svg = select('svg');


//using 'geoAzimuthalEqualArea()' function as a geo-projection to view the world map 
const projection = geoAzimuthalEqualArea();
//projecting the world map using geoPath().projection
const pathGenerator = geoPath().projection(projection);


//adding path element to the created SVG and defining an attribute class as 'earth'
//considering pathGenerator type as Sphere
svg.append('path')
    .attr('class', 'earth')
    .attr('d', pathGenerator({type: 'Sphere'}));

//.json file which containing the data required to visualise world map
json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-10m.json')
  .then(data => {
    const countries = feature(data, data.objects.countries); //creating countries constant
//'selectAll()' function is used to select all the element that matches the specified selector string
    svg.selectAll('path').data(countries.features)
//enter() creates the initial join of data to elements
//defining a class 'countries'
      .enter().append('path')
        .attr('class', 'countries')
        .attr('d', pathGenerator);
  });